<template>
  <el-tooltip :content="helpText" effect="light">
    <el-date-picker
      :value="dateRange"
      @input="change"
      format="dd/MM/yyyy"
      type="daterange"
      :start-placeholder="startPlaceholder"
      :end-placeholder="endPlaceholder">
    </el-date-picker>
  </el-tooltip>
</template>

<script>
  export default {
    name: 'app-date-range-filter',
    props: {
      startPlaceholder: {type: String},
      endPlaceholder: {type: String},
      value: {
        type: Object,
        required: false,
        validator: obj => {
          return '$gte' in obj && '$lt' in obj
        }
      },
      helpText: {type: String, required: true}
    },
    methods: {
      change(newValue) {
        if ( newValue ) {
          let [$gte, $lt] = newValue
          this.$emit('input', {$gte, $lt})
        } else {
          this.$emit('input', null)
        }
      }
    },
    computed: {
      dateRange: {
        get: function() {
          if ( this.value ) {
            return [this.value.$gte, this.value.$lt]
          } else {
            return null
          }
        },
      }
    }
  }
</script>

<style lang="scss">
  .el-date-editor.el-range-editor.el-input__inner.el-date-editor--daterange {
    width: auto;
  }
</style>
